"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/* eslint-disable @typescript-eslint/no-empty-function */
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var Backdrop_1 = tslib_1.__importDefault(require("@mui/material/Backdrop"));
var ScopedCssBaseline_1 = tslib_1.__importDefault(require("@mui/material/ScopedCssBaseline"));
var Delayed_component_1 = tslib_1.__importDefault(require("../delayed/Delayed.component"));
var FeedbackDialog_component_1 = tslib_1.__importDefault(require("../feedbackDialog/FeedbackDialog.component"));
var Canvas_1 = tslib_1.__importDefault(require("../drawing/Canvas"));
var crying_svg_1 = tslib_1.__importDefault(require("../../images/crying.svg"));
var disapointed_svg_1 = tslib_1.__importDefault(require("../../images/disapointed.svg"));
var smiling_svg_1 = tslib_1.__importDefault(require("../../images/smiling.svg"));
var whiteSmiling_svg_1 = tslib_1.__importDefault(require("../../images/whiteSmiling.svg"));
var worried_svg_1 = tslib_1.__importDefault(require("../../images/worried.svg"));
var arrow_svg_1 = tslib_1.__importDefault(require("../../images/arrow.svg"));
require("./UXFeeedBackFloater.css");
var initialFormData = {
    name: '',
    email: '',
    comments: '',
};
var UXFeeedBackFloater = function (_a) {
    var appName = _a.appName, workspaceCode = _a.workspaceCode, token = _a.token;
    var _b = (0, react_1.useState)(true), isCollapse = _b[0], setIsCollapse = _b[1];
    var _c = (0, react_1.useState)(0), rating = _c[0], setRating = _c[1];
    var _d = (0, react_1.useState)(false), clickedAddImage = _d[0], setClickedAddImage = _d[1];
    var _e = (0, react_1.useState)(null), imageData = _e[0], setImageData = _e[1];
    var _f = (0, react_1.useState)(false), isSubmitting = _f[0], setIsSubmitting = _f[1];
    var _g = (0, react_1.useState)(false), submitSuccess = _g[0], setSubmitSuccess = _g[1];
    var _h = (0, react_1.useState)(false), submitError = _h[0], setSubmitError = _h[1];
    var _j = (0, react_1.useState)(initialFormData), formData = _j[0], setFormData = _j[1];
    var iconMap = (0, react_1.useMemo)(function () {
        return {
            1: crying_svg_1.default,
            2: disapointed_svg_1.default,
            3: worried_svg_1.default,
            4: whiteSmiling_svg_1.default,
            5: smiling_svg_1.default,
        };
    }, []);
    var handleClickFloatingButton = function () {
        if (isCollapse) {
            setIsCollapse(false);
        }
    };
    var handleClickEmoji = function (rating) {
        setRating(rating);
        setIsCollapse(true);
    };
    var handleClickAddImage = function (value, formData) {
        setClickedAddImage(value);
        setFormData(formData);
    };
    var handleClickScreenCapture = function (imageData) {
        setImageData(imageData);
        setClickedAddImage(false);
    };
    var getBase64StringFromDataURL = function (dataURL) { return dataURL.replace('data:', '').replace(/^.+,/, ''); };
    var handleSubmit = function (formData) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var comments, fullName, email, response, error_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setIsSubmitting(true);
                    setSubmitError(false);
                    setSubmitSuccess(false);
                    comments = formData.comments, fullName = formData.name, email = formData.email;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, fetch('https://nsldev.nimble.expert/AdminConsole/api/Feedback', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                                authorization: "Bearer ".concat(token),
                            },
                            body: JSON.stringify({
                                comments: comments,
                                email: email,
                                fullName: fullName,
                                screenshotData: imageData ? getBase64StringFromDataURL(imageData) : null,
                                screenshotFileName: imageData ? appName : null,
                                feedbackFiles: [],
                                workspaceCode: workspaceCode,
                            }),
                        })];
                case 2:
                    response = _a.sent();
                    if (response.status === 200 || response.status === 201) {
                        console.log('Feedback API Submit success', response);
                        setSubmitSuccess(true);
                    }
                    else {
                        throw new Error();
                    }
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    setSubmitError(true);
                    setSubmitSuccess(false);
                    console.log('Feedback API Submit error');
                    return [3 /*break*/, 4];
                case 4:
                    setFormData(initialFormData);
                    setIsSubmitting(false);
                    return [2 /*return*/];
            }
        });
    }); };
    var handleDialogClose = function () {
        setRating(0);
        setImageData(null);
        setFormData(initialFormData);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(ScopedCssBaseline_1.default, null,
            react_1.default.createElement("div", { className: (0, classnames_1.default)('floating-button', isCollapse === false && 'floating-button-clicked'), onClick: rating === 0 ? handleClickFloatingButton : function () { } }, isCollapse ? (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", null, "Feed\nback"))) : (react_1.default.createElement(Delayed_component_1.default, { waitBeforeShow: 300 },
                react_1.default.createElement("div", { className: 'detailed-container' },
                    react_1.default.createElement("div", null,
                        react_1.default.createElement("div", { className: 'experience-text' }, "? How is your experience so far"),
                        react_1.default.createElement("div", { className: 'emojiWrapper' }, Object.entries(iconMap).map(function (_key, index) { return (react_1.default.createElement("img", { key: index, src: iconMap[index + 1], alt: 'cryingSVG', className: 'emoji', onClick: function () { return handleClickEmoji(index + 1); } })); }))),
                    react_1.default.createElement("img", { src: arrow_svg_1.default, alt: 'arrow', className: 'arrow', onClick: function () { return setIsCollapse(true); } }))))),
            react_1.default.createElement(FeedbackDialog_component_1.default, { open: rating > 0 && !clickedAddImage, onClickDialogClose: handleDialogClose, rating: rating, onClickAddImage: handleClickAddImage, isScreenCaptured: imageData ? true : false, onClickRemoveImage: function () { return setImageData(null); }, onClickRetakeScreenshot: function () { return setClickedAddImage(true); }, initialFormData: formData, onClickSubmit: handleSubmit, submitAPIResponse: {
                    isSubmitting: isSubmitting,
                    submitSuccess: submitSuccess,
                    submitError: submitError,
                } }),
            react_1.default.createElement(Backdrop_1.default, { sx: {
                    color: '#fff',
                    zIndex: function (theme) { return theme.zIndex.drawer + 1; },
                    backgroundColor: 'rgba(0, 0, 0, 0)',
                }, open: clickedAddImage }, clickedAddImage && (react_1.default.createElement(Canvas_1.default, { onClickCancel: function () { return setClickedAddImage(false); }, onClickSave: handleClickScreenCapture }))))));
};
exports.default = UXFeeedBackFloater;
