import { __awaiter, __generator } from "tslib";
/* eslint-disable @typescript-eslint/no-empty-function */
import React, { useState, useMemo } from 'react';
import classNames from 'classnames';
import Backdrop from '@mui/material/Backdrop';
import ScopedCssBaseline from '@mui/material/ScopedCssBaseline';
import Delayed from '../delayed/Delayed.component';
import FeedbackDialog from '../feedbackDialog/FeedbackDialog.component';
import Canvas from '../drawing/Canvas';
import cryingSVG from '../../images/crying.svg';
import disapointedSVG from '../../images/disapointed.svg';
import smilingSVG from '../../images/smiling.svg';
import whiteSmilingSVG from '../../images/whiteSmiling.svg';
import worriedSVG from '../../images/worried.svg';
import arrowSVG from '../../images/arrow.svg';
import './UXFeeedBackFloater.css';
var initialFormData = {
    name: '',
    email: '',
    comments: '',
};
var UXFeeedBackFloater = function (_a) {
    var appName = _a.appName, workspaceCode = _a.workspaceCode, token = _a.token;
    var _b = useState(true), isCollapse = _b[0], setIsCollapse = _b[1];
    var _c = useState(0), rating = _c[0], setRating = _c[1];
    var _d = useState(false), clickedAddImage = _d[0], setClickedAddImage = _d[1];
    var _e = useState(null), imageData = _e[0], setImageData = _e[1];
    var _f = useState(false), isSubmitting = _f[0], setIsSubmitting = _f[1];
    var _g = useState(false), submitSuccess = _g[0], setSubmitSuccess = _g[1];
    var _h = useState(false), submitError = _h[0], setSubmitError = _h[1];
    var _j = useState(initialFormData), formData = _j[0], setFormData = _j[1];
    var iconMap = useMemo(function () {
        return {
            1: cryingSVG,
            2: disapointedSVG,
            3: worriedSVG,
            4: whiteSmilingSVG,
            5: smilingSVG,
        };
    }, []);
    var handleClickFloatingButton = function () {
        if (isCollapse) {
            setIsCollapse(false);
        }
    };
    var handleClickEmoji = function (rating) {
        setRating(rating);
        setIsCollapse(true);
    };
    var handleClickAddImage = function (value, formData) {
        setClickedAddImage(value);
        setFormData(formData);
    };
    var handleClickScreenCapture = function (imageData) {
        setImageData(imageData);
        setClickedAddImage(false);
    };
    var getBase64StringFromDataURL = function (dataURL) { return dataURL.replace('data:', '').replace(/^.+,/, ''); };
    var handleSubmit = function (formData) { return __awaiter(void 0, void 0, void 0, function () {
        var comments, fullName, email, response, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setIsSubmitting(true);
                    setSubmitError(false);
                    setSubmitSuccess(false);
                    comments = formData.comments, fullName = formData.name, email = formData.email;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, fetch('https://nsldev.nimble.expert/AdminConsole/api/Feedback', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                                authorization: "Bearer ".concat(token),
                            },
                            body: JSON.stringify({
                                comments: comments,
                                email: email,
                                fullName: fullName,
                                screenshotData: imageData ? getBase64StringFromDataURL(imageData) : null,
                                screenshotFileName: imageData ? appName : null,
                                feedbackFiles: [],
                                workspaceCode: workspaceCode,
                            }),
                        })];
                case 2:
                    response = _a.sent();
                    if (response.status === 200 || response.status === 201) {
                        console.log('Feedback API Submit success', response);
                        setSubmitSuccess(true);
                    }
                    else {
                        throw new Error();
                    }
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    setSubmitError(true);
                    setSubmitSuccess(false);
                    console.log('Feedback API Submit error');
                    return [3 /*break*/, 4];
                case 4:
                    setFormData(initialFormData);
                    setIsSubmitting(false);
                    return [2 /*return*/];
            }
        });
    }); };
    var handleDialogClose = function () {
        setRating(0);
        setImageData(null);
        setFormData(initialFormData);
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(ScopedCssBaseline, null,
            React.createElement("div", { className: classNames('floating-button', isCollapse === false && 'floating-button-clicked'), onClick: rating === 0 ? handleClickFloatingButton : function () { } }, isCollapse ? (React.createElement(React.Fragment, null,
                React.createElement("div", null, "Feed\nback"))) : (React.createElement(Delayed, { waitBeforeShow: 300 },
                React.createElement("div", { className: 'detailed-container' },
                    React.createElement("div", null,
                        React.createElement("div", { className: 'experience-text' }, "? How is your experience so far"),
                        React.createElement("div", { className: 'emojiWrapper' }, Object.entries(iconMap).map(function (_key, index) { return (React.createElement("img", { key: index, src: iconMap[index + 1], alt: 'cryingSVG', className: 'emoji', onClick: function () { return handleClickEmoji(index + 1); } })); }))),
                    React.createElement("img", { src: arrowSVG, alt: 'arrow', className: 'arrow', onClick: function () { return setIsCollapse(true); } }))))),
            React.createElement(FeedbackDialog, { open: rating > 0 && !clickedAddImage, onClickDialogClose: handleDialogClose, rating: rating, onClickAddImage: handleClickAddImage, isScreenCaptured: imageData ? true : false, onClickRemoveImage: function () { return setImageData(null); }, onClickRetakeScreenshot: function () { return setClickedAddImage(true); }, initialFormData: formData, onClickSubmit: handleSubmit, submitAPIResponse: {
                    isSubmitting: isSubmitting,
                    submitSuccess: submitSuccess,
                    submitError: submitError,
                } }),
            React.createElement(Backdrop, { sx: {
                    color: '#fff',
                    zIndex: function (theme) { return theme.zIndex.drawer + 1; },
                    backgroundColor: 'rgba(0, 0, 0, 0)',
                }, open: clickedAddImage }, clickedAddImage && (React.createElement(Canvas, { onClickCancel: function () { return setClickedAddImage(false); }, onClickSave: handleClickScreenCapture }))))));
};
export default UXFeeedBackFloater;
